{$I DacDemo.inc}

unit ParamType;

interface

uses
{$IFDEF MSWINDOWS}
  Windows, Messages,
{$ENDIF}
{$IFNDEF KYLIX}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls,
{$ELSE}
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, QStdCtrls,
  QDBCtrls, QComCtrls, QExtCtrls, QGrids, QDBGrids,
{$ENDIF}
{$IFDEF FPC}
  LResources,
{$ENDIF}
  Db, Ora;

type
  TParamTypeForm = class(TForm)
    lbParams: TListBox;
    btClose: TButton;
    rgTypes: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    procedure btCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbParamsClick(Sender: TObject);
    procedure rgTypesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    OraSQL: TOraSQL;
  end;

var
  ParamTypeForm: TParamTypeForm;

implementation

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}

procedure TParamTypeForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TParamTypeForm.FormShow(Sender: TObject);
var
  i:integer;
begin
  if OraSQL <> nil then begin
    lbParams.Items.Clear;
    for i := 0 to OraSQL.Params.Count - 1 do
      lbParams.Items.Add(OraSQL.Params[i].Name);
    if OraSQL.Params.Count > 0 then
      lbParams.ItemIndex:= 0;

    lbParamsClick(nil);
  end;
end;

procedure TParamTypeForm.lbParamsClick(Sender: TObject);
begin
  if lbParams.ItemIndex >= 0 then
    case OraSQL.Params[lbParams.ItemIndex].DataType of
      ftString:
        rgTypes.ItemIndex:= 0;
      ftInteger:
        rgTypes.ItemIndex:= 1;
      ftFloat:
        rgTypes.ItemIndex:= 2;
      ftDate:
        rgTypes.ItemIndex:= 3;
    else
      rgTypes.ItemIndex:= -1;
    end;
end;

procedure TParamTypeForm.rgTypesClick(Sender: TObject);
var
  DataType: TFieldType;
begin
  if lbParams.ItemIndex >= 0 then begin
    case rgTypes.ItemIndex of
      0: DataType:= ftString;
      1: DataType:= ftInteger;
      2: DataType:= ftFloat;
      3: DataType:= ftDate;
    else
      DataType:= ftUnknown;
    end;
    OraSQL.Params[lbParams.ItemIndex].DataType:= DataType;
  end;
end;

initialization
{$IFDEF FPC}
{$I ParamType.lrs}
{$ENDIF}

end.
